﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace CommonLib.Config
{
    public class ParameterOperation
    {
        public static void SetParameter(string path, string key, string value)
        {
            var dic = GetParaDic(path);

            dic[key] = value;

            var xml = SetXElement(dic);

            xml.Save(path);
        }

        public static string GetValue(string key, string path)
        {
            return GetParaDic(path).GetValue(key.ToString());
        }

        private static XElement SetXElement(Dictionary<string, string> vlaue)
        {
            return new XElement("nodes",
                vlaue.Select(x =>
                new XElement("node",
                    new XElement("key", x.Key),
                    new XElement("value", new XCData(x.Value ?? "")
                    ))));
        }

        private static Dictionary<string, string> configObject = new Dictionary<string, string>();

        private static Dictionary<string, string> GetParaDic(string path)
        {
            if (configObject.Count == 0)
            {
                var xml = XElement.Load(path);

                if (xml != null)
                {
                    configObject = xml.Elements("node").Select(x => new { key = x.GetElementValue("key"), value = x.GetElementValue("value") }).ToDictionary(x => x.key, y => y.value);
                }
            }

            return configObject;
        }
    }
}
