﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using CommonLib;

namespace System.IO.IOOperation
{
    public class FileOperation
    {
        private static object lockObject = new object();

        public static void Append(string path, string content)
        {
            Append(path, LibraryHelp.Encoding, content);
        }

        public static void Append(string path, Encoding encoding, string content)
        {
            if (string.IsNullOrEmpty(content)) throw new ArgumentNullException("Content is null or empty");

            lock (lockObject)
            {
                try
                {
                    if (!File.Exists(path))
                    {
                        File.Create(path).Dispose();
                    }

                    File.AppendAllText(path, content, encoding);
                }
                catch { }
            }
        }
    }
}
