﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;
using CommonLib;
namespace System.Timers.AutoTimer
{
    public delegate void TimerStart(object obj);

    public class AutoTimer
    {
        private object obj;

        private TimerStart start;

        private int minutes;

        private System.Timers.Timer time;

        public AutoTimer(TimerStart start, int minutes, object obj)
        {
            if (minutes == 0) throw new Exception("时间应大于0");

            this.start = start;

            this.minutes = minutes;

            this.obj = obj;
        }

        public static void Create(TimerStart start, int minutes, object obj)
        {
            var timer = new AutoTimer(start, minutes, obj);

            timer.Create();
        }

        public void Create()
        {
            time = new System.Timers.Timer(minutes * LibraryHelp.Minutes);

            time.Enabled = true;

            time.AutoReset = true;

            time.Elapsed += new ElapsedEventHandler(time_Elapsed);
        }

        public void Stop()
        {
            time.Stop();
        }

        void time_Elapsed(object sender, ElapsedEventArgs e)
        {
            start.Invoke(obj);
        }
    }
}
